//A very simple Hero model with some basic physics.

package  
{
	/**
	 * ...
	 * @author johno
	 */
	public class Hero 
	{
		public function Hero(aX:Number, aY:Number)
		{
			myX = aX;
			myY = aY;
		}
		
		public function update(aTimePerTick:Number, aLeft:Boolean, aRight:Boolean, anUp:Boolean, aDown:Boolean):void
		{
			//accelerate base on input
			var accX:Number = 0;
			var accY:Number = 0;
			if (aLeft)
			{
				accX = -1;
			}
			if (aRight)
			{
				accX = 1;
			}
			if (anUp)
			{
				accY = -1;
			}
			if (aDown)
			{
				accY = 1;
			}
			if (accX != 0 || accY != 0)
			{
				//normalize acceleration vector
				var l:Number = Math.sqrt(accX * accX + accY * accY);
				accX /= l;
				accY /= l;
				
				//accelerate
				mySpeedX += accX * ACCELERATION * aTimePerTick;
				mySpeedY += accY * ACCELERATION * aTimePerTick;
			}
			
			//friction (down to min speed to avoid jittering)
			if (Math.abs(mySpeedX) > MIN_SPEED)
			{
				mySpeedX += mySpeedX * FRICTION * aTimePerTick;
			}
			else
			{
				mySpeedX = 0;
			}
			if (Math.abs(mySpeedY) > MIN_SPEED)
			{
				mySpeedY += mySpeedY * FRICTION * aTimePerTick;
			}
			else
			{
				mySpeedY = 0;
			}
			
			//move
			myX += mySpeedX * aTimePerTick;
			myY += mySpeedY * aTimePerTick;
		}
		
		//constants
		private static const ACCELERATION:Number = 1536;
		private static const FRICTION:Number = -8;
		private static const MIN_SPEED:Number = 4;
		
		//members
		public var myX:Number = 0;
		public var myY:Number = 0;
		private var mySpeedX:Number = 0;
		private var mySpeedY:Number = 0;
	}
}